import _createClass from "@babel/runtime/helpers/esm/createClass";
import { faker } from '@faker-js/faker';
var IDENTITY_FN = function IDENTITY_FN(i) {
  return i;
};
var instanceRndID;
export var RandomID = /*#__PURE__*/function () {
  function RandomID(id) {
    this._id = id;
  }
  RandomID.create = function create() {
    if (instanceRndID) return instanceRndID;
    var seed = process.env.SEED || Math.ceil(Math.random() * Number.MAX_SAFE_INTEGER);
    instanceRndID = new RandomID(seed);
    console.log("[RandomID.create] Faker created with seed: " + seed);
    return instanceRndID;
  };
  RandomID.restore = function restore() {
    instanceRndID = undefined;
  };
  return _createClass(RandomID, [{
    key: "id",
    get: function get() {
      return this._id;
    }
  }]);
}();
export var FakeGenerator = /*#__PURE__*/function () {
  function FakeGenerator(seed) {
    faker.seed(seed);
    this._faker = faker;
  }
  FakeGenerator.create = function create() {
    var seed = RandomID.create().id;
    return new FakeGenerator(seed);
  };
  var _proto = FakeGenerator.prototype;
  _proto.city = function city() {
    return this._faker.location.city();
  };
  _proto.email = function email() {
    return this._faker.internet.email();
  };
  _proto.uuid = function uuid() {
    return this._faker.string.uuid();
  };
  _proto.words = function words(_ref) {
    var count = _ref.count,
      _ref$replacer = _ref.replacer,
      replacer = _ref$replacer === void 0 ? IDENTITY_FN : _ref$replacer;
    return replacer(this._faker.lorem.words(count));
  };
  _proto.color = function color() {
    return this._faker.color.rgb({
      format: 'hex',
      casing: 'lower'
    });
  };
  _proto.date = function date(_temp) {
    var _ref2 = _temp === void 0 ? {} : _temp,
      from = _ref2.from,
      to = _ref2.to;
    return this._faker.date.between({
      from: from,
      to: to
    });
  };
  _proto.pick = function pick(list) {
    return list[Math.floor(Math.random() * list.length)];
  };
  _proto.bool = function bool() {
    return Math.random() < 0.5;
  };
  _proto.province = function province() {
    return this._faker.location.county();
  };
  _proto.phone = function phone() {
    return this._faker.phone.number();
  };
  _proto.URL = function URL() {
    return this._faker.internet.url();
  };
  _proto.imgURL = function imgURL(_temp2) {
    var _ref3 = _temp2 === void 0 ? {
        removeHost: true
      } : _temp2,
      removeHost = _ref3.removeHost;
    var url = this._faker.image.imageUrl();
    if (!removeHost) return url;
    var uri = new URL(url);
    return uri.pathname.replace('/', '');
  };
  _proto.number = function number(_ref4) {
    var _ref4$min = _ref4.min,
      min = _ref4$min === void 0 ? 0 : _ref4$min,
      _ref4$max = _ref4.max,
      max = _ref4$max === void 0 ? Infinity : _ref4$max;
    var difference = max - min;
    var rand = Math.random();
    rand = Math.floor(rand * difference);
    rand = rand + min;
    return rand;
  };
  _proto.zipCode = function zipCode() {
    return this._faker.location.zipCode();
  };
  return FakeGenerator;
}();