import _createClass from "@babel/runtime/helpers/esm/createClass";
import _inheritsLoose from "@babel/runtime/helpers/esm/inheritsLoose";
import { expect } from 'chai';
import { diffJson } from 'diff';
import { FakeGenerator } from './FakeGenerator';
var MotherObject = function MotherObject() {};
export var ModelMotherObjectFactory = function ModelMotherObjectFactory(Model) {
  return /*#__PURE__*/function (_MotherObject) {
    function ModelMotherObject(_temp) {
      var _this;
      var _ref = _temp === void 0 ? {} : _temp,
        model = _ref.model;
      _this = _MotherObject.call(this) || this;
      _this._model = void 0;
      _this._model = model;
      _this._faker = FakeGenerator.create();
      _this._expect = expect;
      return _this;
    }
    _inheritsLoose(ModelMotherObject, _MotherObject);
    var _proto = ModelMotherObject.prototype;
    _proto.withoutError = function withoutError(_temp2) {
      var _ref2 = _temp2 === void 0 ? {} : _temp2,
        error = _ref2.error;
      expect(error).to.be.eql(null);
      return this;
    };
    _proto.withError = function withError(_temp3) {
      var _ref3 = _temp3 === void 0 ? {} : _temp3,
        error = _ref3.error,
        klass = _ref3.klass;
      expect(error).instanceof(klass);
      return this;
    };
    _proto.isNull = function isNull(_temp4) {
      var _ref4 = _temp4 === void 0 ? {} : _temp4,
        json = _ref4.json;
      expect(json).to.be.eql(null);
    };
    _proto.validateToJSON = function validateToJSON() {
      var _newModel$toLiterals;
      var originalJSON = this.jsonModel();
      var newModel = Model.create(originalJSON);
      var newJSON = (_newModel$toLiterals = newModel.toLiterals == null ? void 0 : newModel.toLiterals()) != null ? _newModel$toLiterals : newModel.toJSON();
      try {
        expect(originalJSON).to.be.eql(newJSON);
      } catch (err) {
        var _Model$constructor;
        var diff = diffJson(originalJSON, newJSON);
        console.error("[ModelMotherObject#validateToJSON] has failed! " + ((_Model$constructor = Model.constructor) == null ? void 0 : _Model$constructor.name) + " doesnt follow the rule: Model.create(instance.toJSON())");
        diff.forEach(function (part) {
          console.log("%c " + part.value, "color: " + (part.added ? 'green' : part.removed ? 'red' : 'grey'));
        });
        throw err;
      }
      return this;
    };
    _proto.equals = function equals(_temp5) {
      var _ref5 = _temp5 === void 0 ? {} : _temp5,
        json = _ref5.json,
        _ref5$expected = _ref5.expected,
        expected = _ref5$expected === void 0 ? this.jsonModel() : _ref5$expected;
      try {
        expect(expected).to.be.eql(json);
      } catch (err) {
        console.error('There are differences between the mother object model and your model');
        var diff = diffJson(expected, json);
        diff.forEach(function (part) {
          console.log("%c " + part.value, "color: " + (part.added ? 'green' : part.removed ? 'red' : 'grey'));
        });
        throw err;
      }
      return this;
    };
    _proto.jsonModel = function jsonModel() {
      var _this$_model$toLitera, _this$_model$toLitera2, _this$_model;
      if (!this._model) throw new Error("[ModelMotherObject#jsonModel] model is undefined model(" + this._model + ")");
      return (_this$_model$toLitera = (_this$_model$toLitera2 = (_this$_model = this._model).toLiterals) == null ? void 0 : _this$_model$toLitera2.call(_this$_model)) != null ? _this$_model$toLitera : this._model.toJSON();
    };
    return _createClass(ModelMotherObject, [{
      key: "expect",
      get: function get() {
        return this._expect;
      }
    }, {
      key: "model",
      get: function get() {
        return this._model;
      },
      set: function set(nextModel) {
        this._model = nextModel;
      }
    }, {
      key: "faker",
      get: function get() {
        return this._faker;
      }
    }]);
  }(MotherObject);
};