import _createClass from "@babel/runtime/helpers/esm/createClass";
import _inheritsLoose from "@babel/runtime/helpers/esm/inheritsLoose";
import { FakeGenerator } from './FakeGenerator';
import { MockFetcherManager } from './Fetcher';
var MotherObject = function MotherObject() {};
export var RequestMotherObjectFactory = function RequestMotherObjectFactory(FetchFetcher, _ref) {
  var InlineError = _ref.InlineError;
  return /*#__PURE__*/function (_MotherObject) {
    function RequestMotherObject() {
      var _this;
      _this = _MotherObject.call(this) || this;
      _this._url = void 0;
      _this._method = void 0;
      _this._error = void 0;
      _this._mock = void 0;
      _this._mockFetcherManager = MockFetcherManager.create(FetchFetcher, {
        InlineError: InlineError
      });
      _this._faker = FakeGenerator.create();
      return _this;
    }
    _inheritsLoose(RequestMotherObject, _MotherObject);
    var _proto = RequestMotherObject.prototype;
    _proto.generate = function generate() {
      throw new Error('[RequestMotherObject#generate] Should be implemented');
    };
    _proto.request = function request(_ref2) {
      var url = _ref2.url,
        _ref2$method = _ref2.method,
        method = _ref2$method === void 0 ? 'get' : _ref2$method;
      this._url = url;
      this._method = method;
      return this;
    };
    _proto.success = function success() {
      if (this._error !== undefined) throw new Error('[RequestMotherObject#success] Dont call to .success after call to .error method');
      this._mock = this.generate(this._faker);
      this._mockFetcherManager.addMock({
        url: this._url,
        method: this._method,
        mock: this._mock
      });
      return this;
    };
    _proto.error = function error(_ref3) {
      var _error = _ref3.error;
      if (!_error) throw new Error('[RequestMotherObject#error] if want to return an error from the API you must to instanciate a error');
      if (this._mock !== undefined) throw new Error('[RequestMotherObject#error] Dont call to .error after call to .success method');
      this._error = _error;
      this._mockFetcherManager.addMock({
        url: this._url,
        method: this._method,
        error: this._error
      });
      return this;
    };
    _proto.toJSON = function toJSON() {
      return this._error ? this._error : this._mock;
    };
    _proto.updateMock = function updateMock() {
      this._mockFetcherManager.addMock({
        url: this._url,
        method: this._method,
        mock: this._mock,
        force: true
      });
      return this;
    };
    _proto.validate = function validate() {
      if (!this._url && !this._method) return;
      this._mockFetcherManager.validate({
        url: this._url,
        method: this._method
      });
    };
    return _createClass(RequestMotherObject, [{
      key: "faker",
      get: function get() {
        return this._faker;
      }
    }, {
      key: "mock",
      get: function get() {
        return this._mock;
      },
      set: function set(nextMock) {
        this._mock = nextMock;
        this.updateMock();
      }
    }]);
  }(MotherObject);
};